<!-- 商品分类  goods_category -->
<template>
  <div>
    <div>
       <el-input class="w200 mr20" placeholder="输入关键字进行过滤" v-model="filterText">
        </el-input>
      <el-button icon="el-icon-circle-plus" size="small" type="success" @click="m_addForm()">新增</el-button>
    </div>
    <div class="mt20" v-loading="m_tableLoading">
      <el-tree ref="tree" :filter-node-method="filterNode" label="name" style="border:1px solid #ddd;padding:10px" children="children" :data="m_list" node-key="id" default-expand-all :expand-on-click-node="false" >

        <span  style='flex: 1; display: flex; align-items: center; justify-content: space-between; font-size: 14px; padding-right: 8px; 'slot-scope="{ node, data }">
          <span>{{ data.name }}</span>
          <span>
             <el-button  class="ml10" type="text" @click="() => copyUrl(node,data)">复制链接</el-button>
            <el-button v-if="data.pid==0" class="ml10 m_green" type="text" @click="() => append(node,data)">添加</el-button>
            <el-button  class="ml10 m_blue" type="text" @click="() => edit(node,data)">编辑</el-button>
            <el-button class="ml10 m_red" type="text" @click="() => remove(node, data)">删除</el-button>
          </span>
        </span>
      </el-tree>
    </div>

    <el-dialog :title="m_isadd|m_isAdd" :visible.sync="m_show" width="600px">
      <el-form :model="formData" :rules="m_rules" ref="ruleForm">
        <el-form-item label="名称" label-width="80px" prop="name">
          <el-input v-model="formData.name" auto-complete="off"></el-input>
        </el-form-item>

        <el-form-item label="图片" label-width="80px">
          <el-upload class="avatar-uploader" :action="m_action" :show-file-list="false" name="images" :with-credentials="true" :on-success="handleAvatarSuccess">
            <img v-if="formData.image_url" :src="formData.image_url" class="avatar">
            <i v-else class="el-icon-plus avatar-uploader-icon"></i>
          </el-upload>
          <p class="m_red">( 请上传图片规格 宽：高 1:1 )</p>
        </el-form-item>

        <el-form-item label="类型" label-width="80px" prop="type">
          <el-radio-group v-model="formData.type">
            <el-radio v-for="item in locBaseData.goodsClassType" :label="item.id" :key="item.id">{{item.name}}</el-radio>
          </el-radio-group>
        </el-form-item>
   

         <el-form-item label="状态" label-width="80px" prop="status">
          <el-radio-group v-model="formData.status">
            <el-radio v-for="item in locBaseData.status" :label="item.id" :key="item.id">{{item.name}}</el-radio>
          </el-radio-group>
        </el-form-item>

        <!-- <el-form-item label="概述" label-width="80px">
          <el-input v-model="formData.description" auto-complete="off"></el-input>
        </el-form-item>
        <el-form-item label="跳转地址" label-width="80px">
          <el-input v-model="formData.url" auto-complete="off"></el-input>
        </el-form-item> -->

        <el-form-item label="排序" label-width="80px" >
          <el-input v-model="formData.sort" auto-complete="off"></el-input>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="m_show = false">取 消</el-button>
        <el-button type="primary" :loading="m_loading" @click.native="sureOption">确 定</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import * as api from '@/api/index'
export default {
  name: 'goods_category',
  data() {
    return {
      m_list: [],

      formData: {

        name: '',//名称
       // description: '',//概述
        image_url: '',//图片
        pid: '0', //父级ID,0 为顶级分类
        //url: '',//跳转地址
        status: '0',//状态 0:正常 1:屏蔽
        sort: '0',//排序 (从大到小排序) ,
        type:'0' , //类型 0:外部分类 1:自营品牌分类
      },

      filterText:'',

      m_rules: {
        name: [{ required: true, message: '请输入', trigger: 'blur' }],
        status: [{ required: true, message: '请输入', trigger: 'change' }],

      }

    }
  },

    watch: {
    filterText(val) {
      this.$refs.tree.filter(val);
    }
  },

  mounted() {
    this.init()
  },
  methods: {
    init() {
      this.getDatalist()
    },

    //获取数据信息
    getDatalist() {
      this.m_tableLoading = true
      this.m_api.goods_categories().then(res => {
        //console.log(res)
        this.m_list = res.data

      }).finally(() => {
        this.m_tableLoading = false
      })
    },

    append(node, data) {
      //   console.log(data)
      this.m_addForm()
      this.formData.pid = data.id
    },

    remove(node, data) {
    //   console.log(node, data)
      this.m_oneDel(data)
    },

    edit(node, data) {
    //   console.log(node, data)
      this.m_editForm(data)
    },

    //添加
    addData() {
      this.m_loading = true
      api.goods_category_add(this.formData).then(res => {

        // 添加成功
        this.m_success('添加成功')
        this.m_show = false
        this.getDatalist()
      }).catch(res => {

      }).finally(() => {
        this.m_loading = false
      })
    },

    //编辑
    editData() {
      this.m_loading = true
      api.goods_category_update(this.formData).then(res => {
        // 修改成功
        this.m_success('修改成功')
        this.m_show = false
        this.getDatalist()
      }).catch(res => {

      }).finally(() => {
        this.m_loading = false
      })
    },


    //删除
    delData(id) {
      let m_delId = id ? [id] : this.m_delId
      this.m_loading = true
      api.goods_category_delete(m_delId).then(res => {
        // 删除成功
        this.m_loading = false
        this.m_success('删除成功')
        this.getDatalist()
      }).catch(res => {
          
        this.m_loading = false
      })
    },




    handleAvatarSuccess(res, file) {
      this.formData.image_url = res.data

    },

    copyUrl(n,v){
      let url = `/goodsList?cid=${v.id}&name=${v.name}`
      this.m_copy(url,()=>{
        this.m_success('复制成功')
      })

    },

       filterNode(value, data) {
      if (!value) return true;
      return data.name.indexOf(value) !== -1;
    }




  }
}

</script>
<style lang='scss' scoped>
.ad_img {
  width: 100px;
  height: 100px;
}
.avatar-uploader .el-upload {
  border: 1px dashed #d9d9d9;
  border-radius: 6px;
  cursor: pointer;
  position: relative;
  overflow: hidden;
}
.avatar-uploader .el-upload:hover {
  border-color: #409eff;
}
.avatar-uploader-icon {
  font-size: 28px;
  color: #8c939d;
  width: 178px;
  height: 178px;
  line-height: 178px;
  text-align: center;
  border: 1px dashed #d9d9d9;
}
.avatar {
  width: 178px;
  height: 178px;
  display: block;
  border: 1px dashed #d9d9d9;
}
</style>